--- old/usr/src/uts/common/fs/vnode.c	Wed Oct  5 00:33:45 2016
+++ new/usr/src/uts/common/fs/vnode.c	Wed Oct  5 00:33:45 2016
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2016, Joyent, Inc.
+ * Copyright (c) 2014, Joyent, Inc. All rights reserved.
  */
 
 /*	Copyright (c) 1983, 1984, 1985, 1986, 1987, 1988, 1989 AT&T	*/
@@ -66,8 +66,6 @@
 #include <fs/fs_subr.h>
 #include <sys/taskq.h>
 #include <fs/fs_reparse.h>
-#include <sys/time.h>
-#include <sys/sdt.h>
 
 /* Determine if this vnode is a file that is read-only */
 #define	ISROFILE(vp)	\
@@ -104,9 +102,6 @@
 /* Global variable which enables/disables the vopstats collection */
 int vopstats_enabled = 1;
 
-/* Global used for empty/invalid v_path */
-char *vn_vpath_empty = "";
-
 /*
  * forward declarations for internal vnode specific data (vsd)
  */
@@ -208,7 +203,6 @@
 #define	VOP_LATENCY_10MS	10000000
 #define	VOP_LATENCY_100MS	100000000
 #define	VOP_LATENCY_1S		1000000000
-#define	VOP_LATENCY_10S		10000000000
 
 /*
  * Convert stat(2) formats to vnode types and vice versa.  (Knows about
@@ -1653,7 +1647,7 @@
 
 int
 vn_renameat(vnode_t *fdvp, char *fname, vnode_t *tdvp,
-    char *tname, enum uio_seg seg)
+		char *tname, enum uio_seg seg)
 {
 	int error;
 	struct vattr vattr;
@@ -2294,8 +2288,7 @@
 	cv_init(&vp->v_cv, NULL, CV_DEFAULT, NULL);
 	rw_init(&vp->v_nbllock, NULL, RW_DEFAULT, NULL);
 	vp->v_femhead = NULL;	/* Must be done before vn_reinit() */
-	vp->v_path = vn_vpath_empty;
-	vp->v_path_stamp = 0;
+	vp->v_path = NULL;
 	vp->v_mpssdata = NULL;
 	vp->v_vsd = NULL;
 	vp->v_fopdata = NULL;
@@ -2342,7 +2335,6 @@
 vn_recycle(vnode_t *vp)
 {
 	ASSERT(vp->v_pages == NULL);
-	VERIFY(vp->v_path != NULL);
 
 	/*
 	 * XXX - This really belongs in vn_reinit(), but we have some issues
@@ -2365,11 +2357,10 @@
 		kmem_free(vp->v_femhead, sizeof (*(vp->v_femhead)));
 		vp->v_femhead = NULL;
 	}
-	if (vp->v_path != vn_vpath_empty) {
+	if (vp->v_path) {
 		kmem_free(vp->v_path, strlen(vp->v_path) + 1);
-		vp->v_path = vn_vpath_empty;
+		vp->v_path = NULL;
 	}
-	vp->v_path_stamp = 0;
 
 	if (vp->v_fopdata != NULL) {
 		free_fopdata(vp);
@@ -2440,10 +2431,9 @@
 	 */
 	ASSERT((vp->v_count == 0) || (vp->v_count == 1));
 	ASSERT(vp->v_count_dnlc == 0);
-	VERIFY(vp->v_path != NULL);
-	if (vp->v_path != vn_vpath_empty) {
+	if (vp->v_path != NULL) {
 		kmem_free(vp->v_path, strlen(vp->v_path) + 1);
-		vp->v_path = vn_vpath_empty;
+		vp->v_path = NULL;
 	}
 
 	/* If FEM was in use, make sure everything gets cleaned up */
@@ -2977,239 +2967,125 @@
 }
 
 /*
- * The value stored in v_path is relative to rootdir, located in the global
- * zone.  Zones or chroot environments which reside deeper inside the VFS
- * hierarchy will have a relative view of MAXPATHLEN since they are unaware of
- * what lies below their perceived root.  In order to keep v_path usable for
- * these child environments, its allocations are allowed to exceed MAXPATHLEN.
- *
- * An upper bound of max_vnode_path is placed upon v_path allocations to
- * prevent the system from going too wild at the behest of pathological
- * behavior from the operator.
+ * Given a starting vnode and a path, updates the path in the target vnode in
+ * a safe manner.  If the vnode already has path information embedded, then the
+ * cached path is left untouched.
  */
+
 size_t max_vnode_path = 4 * MAXPATHLEN;
 
-
 void
-vn_clearpath(vnode_t *vp, hrtime_t compare_stamp)
+vn_setpath(vnode_t *rootvp, struct vnode *startvp, struct vnode *vp,
+    const char *path, size_t plen)
 {
-	char *buf;
+	char	*rpath;
+	vnode_t	*base;
+	size_t	rpathlen, rpathalloc;
+	int	doslash = 1;
 
-	mutex_enter(&vp->v_lock);
+	if (*path == '/') {
+		base = rootvp;
+		path++;
+		plen--;
+	} else {
+		base = startvp;
+	}
+
 	/*
-	 * If the snapshot of v_path_stamp passed in via compare_stamp does not
-	 * match the present value on the vnode, it indicates that subsequent
-	 * changes have occurred.  The v_path value is not cleared in this case
-	 * since the new value may be valid.
+	 * We cannot grab base->v_lock while we hold vp->v_lock because of
+	 * the potential for deadlock.
 	 */
-	if (compare_stamp != 0 && vp->v_path_stamp != compare_stamp) {
-		mutex_exit(&vp->v_lock);
+	mutex_enter(&base->v_lock);
+	if (base->v_path == NULL) {
+		mutex_exit(&base->v_lock);
 		return;
 	}
-	buf = vp->v_path;
-	vp->v_path = vn_vpath_empty;
-	vp->v_path_stamp = 0;
-	mutex_exit(&vp->v_lock);
-	if (buf != vn_vpath_empty) {
-		kmem_free(buf, strlen(buf) + 1);
-	}
-}
 
-static void
-vn_setpath_common(vnode_t *pvp, vnode_t *vp, const char *name, size_t len,
-    boolean_t is_rename)
-{
-	char *buf, *oldbuf;
-	hrtime_t pstamp;
-	size_t baselen, buflen = 0;
+	rpathlen = strlen(base->v_path);
+	rpathalloc = rpathlen + plen + 1;
+	/* Avoid adding a slash if there's already one there */
+	if (base->v_path[rpathlen-1] == '/')
+		doslash = 0;
+	else
+		rpathalloc++;
 
-	/* Handle the vn_setpath_str case. */
-	if (pvp == NULL) {
-		if (len + 1 > max_vnode_path) {
-			DTRACE_PROBE4(vn__setpath__too__long, vnode_t *, pvp,
-			    vnode_t *, vp, char *, name, size_t, len + 1);
-			return;
-		}
-		buf = kmem_alloc(len + 1, KM_SLEEP);
-		bcopy(name, buf, len);
-		buf[len] = '\0';
+	/*
+	 * We don't want to call kmem_alloc(KM_SLEEP) with kernel locks held,
+	 * so we must do this dance.  If, by chance, something changes the path,
+	 * just give up since there is no real harm.
+	 */
+	mutex_exit(&base->v_lock);
 
-		mutex_enter(&vp->v_lock);
-		oldbuf = vp->v_path;
-		vp->v_path = buf;
-		vp->v_path_stamp = gethrtime();
-		mutex_exit(&vp->v_lock);
-		if (oldbuf != vn_vpath_empty) {
-			kmem_free(oldbuf, strlen(oldbuf) + 1);
-		}
+	/* Paths should stay within reason */
+	if (rpathalloc > max_vnode_path)
 		return;
-	}
 
-	/* Take snapshot of parent dir */
-	mutex_enter(&pvp->v_lock);
-retrybuf:
-	if (pvp->v_path == vn_vpath_empty) {
-		/*
-		 * Without v_path from the parent directory, generating a child
-		 * path from the name is impossible.
-		 */
-		if (len > 0) {
-			pstamp = pvp->v_path_stamp;
-			mutex_exit(&pvp->v_lock);
-			vn_clearpath(vp, pstamp);
-			return;
-		}
+	rpath = kmem_alloc(rpathalloc, KM_SLEEP);
 
-		/*
-		 * The only feasible case here is where a NUL lookup is being
-		 * performed on rootdir prior to its v_path being populated.
-		 */
-		ASSERT(pvp->v_path_stamp = 0);
-		baselen = 0;
-		pstamp = 0;
-	} else {
-		pstamp = pvp->v_path_stamp;
-		baselen = strlen(pvp->v_path);
-		/* ignore a trailing slash if present */
-		if (pvp->v_path[baselen - 1] == '/') {
-			/* This should only the be case for rootdir */
-			ASSERT(baselen == 1 && pvp == rootdir);
-			baselen--;
-		}
-	}
-	mutex_exit(&pvp->v_lock);
-
-	if (buflen != 0) {
-		/* Free the existing (mis-sized) buffer in case of retry */
-		kmem_free(buf, buflen);
-	}
-	/* base, '/', name and trailing NUL */
-	buflen = baselen + len + 2;
-	if (buflen > max_vnode_path) {
-		DTRACE_PROBE4(vn__setpath_too__long, vnode_t *, pvp,
-		    vnode_t *, vp, char *, name, size_t, buflen);
+	mutex_enter(&base->v_lock);
+	if (base->v_path == NULL || strlen(base->v_path) != rpathlen) {
+		mutex_exit(&base->v_lock);
+		kmem_free(rpath, rpathalloc);
 		return;
 	}
-	buf = kmem_alloc(buflen, KM_SLEEP);
+	bcopy(base->v_path, rpath, rpathlen);
+	mutex_exit(&base->v_lock);
 
-	mutex_enter(&pvp->v_lock);
-	if (pvp->v_path_stamp != pstamp) {
-		size_t vlen;
+	if (doslash)
+		rpath[rpathlen++] = '/';
+	bcopy(path, rpath + rpathlen, plen);
+	rpath[rpathlen + plen] = '\0';
 
-		/*
-		 * Since v_path_stamp changed on the parent, it is likely that
-		 * v_path has been altered as well.  If the length does not
-		 * exactly match what was previously measured, the buffer
-		 * allocation must be repeated for proper sizing.
-		 */
-		if (pvp->v_path == vn_vpath_empty) {
-			/* Give up if parent lack v_path */
-			mutex_exit(&pvp->v_lock);
-			kmem_free(buf, buflen);
-			return;
-		}
-		vlen = strlen(pvp->v_path);
-		if (pvp->v_path[vlen - 1] == '/') {
-			vlen--;
-		}
-		if (vlen != baselen) {
-			goto retrybuf;
-		}
-	}
-	bcopy(pvp->v_path, buf, baselen);
-	mutex_exit(&pvp->v_lock);
-
-	buf[baselen] = '/';
-	baselen++;
-	bcopy(name, &buf[baselen], len + 1);
-
 	mutex_enter(&vp->v_lock);
-	if (vp->v_path_stamp == 0) {
-		/* never-visited vnode can inherit stamp from parent */
-		ASSERT(vp->v_path == vn_vpath_empty);
-		vp->v_path_stamp = pstamp;
-		vp->v_path = buf;
+	if (vp->v_path != NULL) {
 		mutex_exit(&vp->v_lock);
-	} else if (vp->v_path_stamp < pstamp || is_rename) {
-		/*
-		 * Install the updated path and stamp, ensuring that the v_path
-		 * pointer is valid at all times for dtrace.
-		 */
-		oldbuf = vp->v_path;
-		vp->v_path = buf;
-		vp->v_path_stamp = gethrtime();
-		mutex_exit(&vp->v_lock);
-		kmem_free(oldbuf, strlen(oldbuf) + 1);
+		kmem_free(rpath, rpathalloc);
 	} else {
-		/*
-		 * If the timestamp matches or is greater, it means another
-		 * thread performed the update first while locks were dropped
-		 * here to make the allocation.  We defer to the newer value.
-		 */
+		vp->v_path = rpath;
 		mutex_exit(&vp->v_lock);
-		kmem_free(buf, buflen);
 	}
-	ASSERT(MUTEX_NOT_HELD(&vp->v_lock));
 }
 
+/*
+ * Sets the path to the vnode to be the given string, regardless of current
+ * context.  The string must be a complete path from rootdir.  This is only used
+ * by fsop_root() for setting the path based on the mountpoint.
+ */
 void
-vn_updatepath(vnode_t *pvp, vnode_t *vp, const char *name)
+vn_setpath_str(struct vnode *vp, const char *str, size_t len)
 {
-	size_t len;
+	char *buf = kmem_alloc(len + 1, KM_SLEEP);
 
-	/*
-	 * If the parent is older or empty, there's nothing further to do.
-	 */
-	if (pvp->v_path == vn_vpath_empty ||
-	    pvp->v_path_stamp <= vp->v_path_stamp) {
+	mutex_enter(&vp->v_lock);
+	if (vp->v_path != NULL) {
+		mutex_exit(&vp->v_lock);
+		kmem_free(buf, len + 1);
 		return;
 	}
 
-	/*
-	 * Given the lack of appropriate context, meaningful updates to v_path
-	 * cannot be made for during lookups for the '.' or '..' entries.
-	 */
-	len = strlen(name);
-	if (len == 0 || (len == 1 && name[0] == '.') ||
-	    (len == 2 && name[0] == '.' && name[1] == '.')) {
-		return;
-	}
+	vp->v_path = buf;
+	bcopy(str, vp->v_path, len);
+	vp->v_path[len] = '\0';
 
-	vn_setpath_common(pvp, vp, name, len, B_FALSE);
+	mutex_exit(&vp->v_lock);
 }
 
 /*
- * Given a starting vnode and a path, updates the path in the target vnode in
- * a safe manner.  If the vnode already has path information embedded, then the
- * cached path is left untouched.
- */
-/* ARGSUSED */
-void
-vn_setpath(vnode_t *rootvp, vnode_t *pvp, vnode_t *vp, const char *name,
-    size_t len)
-{
-	vn_setpath_common(pvp, vp, name, len, B_FALSE);
-}
-
-/*
- * Sets the path to the vnode to be the given string, regardless of current
- * context.  The string must be a complete path from rootdir.  This is only used
- * by fsop_root() for setting the path based on the mountpoint.
- */
-void
-vn_setpath_str(vnode_t *vp, const char *str, size_t len)
-{
-	vn_setpath_common(NULL, vp, str, len, B_FALSE);
-}
-
-/*
  * Called from within filesystem's vop_rename() to handle renames once the
  * target vnode is available.
  */
 void
-vn_renamepath(vnode_t *pvp, vnode_t *vp, const char *name, size_t len)
+vn_renamepath(vnode_t *dvp, vnode_t *vp, const char *nm, size_t len)
 {
-	vn_setpath_common(pvp, vp, name, len, B_TRUE);
+	char *tmp;
+
+	mutex_enter(&vp->v_lock);
+	tmp = vp->v_path;
+	vp->v_path = NULL;
+	mutex_exit(&vp->v_lock);
+	vn_setpath(rootdir, dvp, vp, nm, len);
+	if (tmp != NULL)
+		kmem_free(tmp, strlen(tmp) + 1);
 }
 
 /*
@@ -3220,42 +3096,37 @@
 vn_copypath(struct vnode *src, struct vnode *dst)
 {
 	char *buf;
-	hrtime_t stamp;
-	size_t buflen;
+	int alloc;
 
 	mutex_enter(&src->v_lock);
-	if (src->v_path == vn_vpath_empty) {
+	if (src->v_path == NULL) {
 		mutex_exit(&src->v_lock);
 		return;
 	}
-	buflen = strlen(src->v_path) + 1;
-	mutex_exit(&src->v_lock);
+	alloc = strlen(src->v_path) + 1;
 
-	buf = kmem_alloc(buflen, KM_SLEEP);
-
+	/* avoid kmem_alloc() with lock held */
+	mutex_exit(&src->v_lock);
+	buf = kmem_alloc(alloc, KM_SLEEP);
 	mutex_enter(&src->v_lock);
-	if (src->v_path == vn_vpath_empty ||
-	    strlen(src->v_path) + 1 != buflen) {
+	if (src->v_path == NULL || strlen(src->v_path) + 1 != alloc) {
 		mutex_exit(&src->v_lock);
-		kmem_free(buf, buflen);
+		kmem_free(buf, alloc);
 		return;
 	}
-	bcopy(src->v_path, buf, buflen);
-	stamp = src->v_path_stamp;
+	bcopy(src->v_path, buf, alloc);
 	mutex_exit(&src->v_lock);
 
 	mutex_enter(&dst->v_lock);
-	if (dst->v_path != vn_vpath_empty) {
+	if (dst->v_path != NULL) {
 		mutex_exit(&dst->v_lock);
-		kmem_free(buf, buflen);
+		kmem_free(buf, alloc);
 		return;
 	}
 	dst->v_path = buf;
-	dst->v_path_stamp = stamp;
 	mutex_exit(&dst->v_lock);
 }
 
-
 /*
  * XXX Private interface for segvn routines that handle vnode
  * large page segments.
@@ -3444,15 +3315,10 @@
 			else if (lat < VOP_LATENCY_1S) {
 				atomic_inc_64(&zvp->zv_10ms_ops.value.ui64);
 				atomic_inc_64(&zvp->zv_100ms_ops.value.ui64);
-			} else if (lat < VOP_LATENCY_10S) {
-				atomic_inc_64(&zvp->zv_10ms_ops.value.ui64);
-				atomic_inc_64(&zvp->zv_100ms_ops.value.ui64);
-				atomic_inc_64(&zvp->zv_1s_ops.value.ui64);
 			} else {
 				atomic_inc_64(&zvp->zv_10ms_ops.value.ui64);
 				atomic_inc_64(&zvp->zv_100ms_ops.value.ui64);
 				atomic_inc_64(&zvp->zv_1s_ops.value.ui64);
-				atomic_inc_64(&zvp->zv_10s_ops.value.ui64);
 			}
 		}
 	}
@@ -3512,15 +3378,10 @@
 			else if (lat < VOP_LATENCY_1S) {
 				atomic_inc_64(&zvp->zv_10ms_ops.value.ui64);
 				atomic_inc_64(&zvp->zv_100ms_ops.value.ui64);
-			} else if (lat < VOP_LATENCY_10S) {
-				atomic_inc_64(&zvp->zv_10ms_ops.value.ui64);
-				atomic_inc_64(&zvp->zv_100ms_ops.value.ui64);
-				atomic_inc_64(&zvp->zv_1s_ops.value.ui64);
 			} else {
 				atomic_inc_64(&zvp->zv_10ms_ops.value.ui64);
 				atomic_inc_64(&zvp->zv_100ms_ops.value.ui64);
 				atomic_inc_64(&zvp->zv_1s_ops.value.ui64);
-				atomic_inc_64(&zvp->zv_10s_ops.value.ui64);
 			}
 		}
 	}
@@ -3688,7 +3549,9 @@
 	}
 	if (ret == 0 && *vpp) {
 		VOPSTATS_UPDATE(*vpp, lookup);
-		vn_updatepath(dvp, *vpp, nm);
+		if ((*vpp)->v_path == NULL) {
+			vn_setpath(rootdir, dvp, *vpp, nm, strlen(nm));
+		}
 	}
 
 	return (ret);
@@ -3728,7 +3591,9 @@
 	    (dvp, name, vap, excl, mode, vpp, cr, flags, ct, vsecp);
 	if (ret == 0 && *vpp) {
 		VOPSTATS_UPDATE(*vpp, create);
-		vn_updatepath(dvp, *vpp, name);
+		if ((*vpp)->v_path == NULL) {
+			vn_setpath(rootdir, dvp, *vpp, name, strlen(name));
+		}
 	}
 
 	return (ret);
@@ -3848,7 +3713,10 @@
 	    (dvp, dirname, vap, vpp, cr, ct, flags, vsecp);
 	if (ret == 0 && *vpp) {
 		VOPSTATS_UPDATE(*vpp, mkdir);
-		vn_updatepath(dvp, *vpp, dirname);
+		if ((*vpp)->v_path == NULL) {
+			vn_setpath(rootdir, dvp, *vpp, dirname,
+			    strlen(dirname));
+		}
 	}
 
 	return (ret);
--- old/usr/src/uts/common/fs/zfs/zfs_vnops.c	Wed Oct  5 00:33:46 2016
+++ new/usr/src/uts/common/fs/zfs/zfs_vnops.c	Wed Oct  5 00:33:46 2016
@@ -686,17 +686,6 @@
 	if (limit == RLIM64_INFINITY || limit > MAXOFFSET_T)
 		limit = MAXOFFSET_T;
 
-	/*
-	 * Pre-fault the pages to ensure slow (eg NFS) pages
-	 * don't hold up txg.
-	 * Skip this if uio contains loaned arc_buf.
-	 */
-	if ((uio->uio_extflg == UIO_XUIO) &&
-	    (((xuio_t *)uio)->xu_type == UIOTYPE_ZEROCOPY))
-		xuio = (xuio_t *)uio;
-	else
-		uio_prefaultpages(n, uio);
-
 	ZFS_ENTER(zfsvfs);
 	ZFS_VERIFY_ZP(zp);
 
@@ -749,6 +738,17 @@
 	}
 
 	/*
+	 * Pre-fault the pages to ensure slow (eg NFS) pages
+	 * don't hold up txg.
+	 * Skip this if uio contains loaned arc_buf.
+	 */
+	if ((uio->uio_extflg == UIO_XUIO) &&
+	    (((xuio_t *)uio)->xu_type == UIOTYPE_ZEROCOPY))
+		xuio = (xuio_t *)uio;
+	else
+		uio_prefaultpages(MIN(n, max_blksz), uio);
+
+	/*
 	 * If in append mode, set the io offset pointer to eof.
 	 */
 	if (ioflag & FAPPEND) {
@@ -992,6 +992,9 @@
 			break;
 		ASSERT(tx_bytes == nbytes);
 		n -= nbytes;
+
+		if (!xuio && n > 0)
+			uio_prefaultpages(MIN(n, max_blksz), uio);
 	}
 
 	zfs_range_unlock(rl);
@@ -4258,8 +4261,6 @@
 		    &zp->z_pflags, 8);
 		zfs_tstamp_update_setup(zp, CONTENT_MODIFIED, mtime, ctime,
 		    B_TRUE);
-		err = sa_bulk_update(zp->z_sa_hdl, bulk, count, tx);
-
 		zfs_log_write(zfsvfs->z_log, tx, TX_WRITE, zp, off, len, 0);
 	}
 	dmu_tx_commit(tx);
@@ -4795,6 +4796,10 @@
 	ASSERT3U(VTOZ(vp)->z_mapcnt, >=, pages);
 	atomic_add_64(&VTOZ(vp)->z_mapcnt, -pages);
 
+	if ((flags & MAP_SHARED) && (prot & PROT_WRITE) &&
+	    vn_has_cached_data(vp))
+		(void) VOP_PUTPAGE(vp, off, len, B_ASYNC, cr, ct);
+
 	return (0);
 }
 
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/inet/ip/ipclassifier.c	Wed Oct  5 00:33:46 2016
+++ new/usr/src/uts/common/inet/ip/ipclassifier.c	Wed Oct  5 00:33:46 2016
@@ -920,7 +920,6 @@
 void
 ipcl_hash_insert_wildcard(connf_t *connfp, conn_t *connp)
 {
-	conn_t **list, *prev, *next;
 	conn_t *pconnp = NULL, *nconnp;
 	boolean_t isv4mapped = IN6_IS_ADDR_V4MAPPED(&connp->conn_laddr_v6);
 
No differences encountered
No differences encountered
--- old/usr/src/uts/common/inet/sockmods/datafilt.c	Wed Oct  5 00:33:47 2016
+++ new/usr/src/uts/common/inet/sockmods/datafilt.c	Wed Oct  5 00:33:47 2016
@@ -1,26 +1,27 @@
 /*
- * This file and its contents are supplied under the terms of the
- * Common Development and Distribution License ("CDDL"), version 1.0.
- * You may only use this file in accordance with the terms of version
- * 1.0 of the CDDL.
+ * CDDL HEADER START
  *
- * A full copy of the text of the CDDL should have accompanied this
- * source.  A copy of the CDDL is also available via the Internet at
- * http://www.illumos.org/license/CDDL.
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
  */
-
 /*
  * Copyright (c) 2012, OmniTI Computer Consulting, Inc. All rights reserved.
  */
 
-/*
- * This file implements a socketfilter used to deter TCP connections.
- * To defer a connection means to delay the return of accept(3SOCKET)
- * until at least one byte is ready to be read(2). This filter may be
- * applied automatically or programmatically through the use of
- * soconfig(1M) and setsockopt(3SOCKET).
- */
-
 #include <sys/kmem.h>
 #include <sys/systm.h>
 #include <sys/stropts.h>
@@ -30,8 +31,6 @@
 #include <sys/note.h>
 #include <sys/taskq.h>
 
-#define	DATAFILT_MODULE "datafilt"
-
 static struct modlmisc dataf_modlmisc = {
 	&mod_miscops,
 	"Kernel data-ready socket filter"
@@ -43,37 +42,39 @@
 	NULL
 };
 
-static sof_rval_t
+#define	DATAFILT_MODULE "datafilt"
+
+/* ARGSUSED */
+sof_rval_t
 dataf_attach_passive_cb(sof_handle_t handle, sof_handle_t ph,
     void *parg, struct sockaddr *laddr, socklen_t laddrlen,
     struct sockaddr *faddr, socklen_t faddrlen, void **cookiep)
 {
-	_NOTE(ARGUNUSED(handle, ph, parg, laddr, laddrlen, faddr, faddrlen,
-	cookiep));
 	return (SOF_RVAL_DEFER);
 }
 
-static void
+void
 dataf_detach_cb(sof_handle_t handle, void *cookie, cred_t *cr)
 {
 	_NOTE(ARGUNUSED(handle, cookie, cr));
 }
 
-static mblk_t *
+/*
+ * Called for each incoming segment.
+ */
+mblk_t *
 dataf_data_in_cb(sof_handle_t handle, void *cookie, mblk_t *mp, int flags,
     size_t *lenp)
 {
 	_NOTE(ARGUNUSED(cookie, flags, lenp));
 
-	if (mp != NULL && MBLKL(mp) > 0) {
+	if (mp != NULL && MBLKL(mp) > 0)
 		sof_newconn_ready(handle);
-		sof_bypass(handle);
-	}
 
 	return (mp);
 }
 
-static sof_ops_t dataf_ops = {
+sof_ops_t dataf_ops = {
 	.sofop_attach_passive = dataf_attach_passive_cb,
 	.sofop_detach = dataf_detach_cb,
 	.sofop_data_in = dataf_data_in_cb
@@ -82,29 +83,29 @@
 int
 _init(void)
 {
-	int err;
+	int error;
 
 	/*
 	 * This module is safe to attach even after some preliminary socket
 	 * setup calls have taken place. See the comment for SOF_ATT_SAFE.
 	 */
-	err = sof_register(SOF_VERSION, DATAFILT_MODULE, &dataf_ops,
+	error = sof_register(SOF_VERSION, DATAFILT_MODULE, &dataf_ops,
 	    SOF_ATT_SAFE);
-	if (err != 0)
-		return (err);
-	if ((err = mod_install(&dataf_modlinkage)) != 0)
+	if (error != 0)
+		return (error);
+	if ((error = mod_install(&dataf_modlinkage)) != 0)
 		(void) sof_unregister(DATAFILT_MODULE);
 
-	return (err);
+	return (error);
 }
 
 int
 _fini(void)
 {
-	int err;
+	int error;
 
-	if ((err = sof_unregister(DATAFILT_MODULE)) != 0)
-		return (err);
+	if ((error = sof_unregister(DATAFILT_MODULE)) != 0)
+		return (error);
 
 	return (mod_remove(&dataf_modlinkage));
 }
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/inet/tcp_impl.h	Wed Oct  5 00:33:48 2016
+++ new/usr/src/uts/common/inet/tcp_impl.h	Wed Oct  5 00:33:48 2016
@@ -61,9 +61,9 @@
  * by setting it to 0.
  */
 #define	TCP_XMIT_LOWATER	4096
-#define	TCP_XMIT_HIWATER	128000
+#define	TCP_XMIT_HIWATER	49152
 #define	TCP_RECV_LOWATER	2048
-#define	TCP_RECV_HIWATER	1048576
+#define	TCP_RECV_HIWATER	128000
 
 /*
  * Bind hash list size and has function.  It has to be a power of 2 for
--- old/usr/src/uts/common/inet/udp/udp.c	Wed Oct  5 00:33:48 2016
+++ new/usr/src/uts/common/inet/udp/udp.c	Wed Oct  5 00:33:48 2016
@@ -22,7 +22,6 @@
  * Copyright (c) 1991, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2014, OmniTI Computer Consulting, Inc. All rights reserved.
- * Copyright 2015, Joyent, Inc.
  */
 /* Copyright (c) 1990 Mentat Inc. */
 
@@ -77,8 +76,7 @@
 #include <inet/ipclassifier.h>
 #include <sys/squeue_impl.h>
 #include <inet/ipnet.h>
-#include <sys/vxlan.h>
-#include <inet/inet_hash.h>
+#include <sys/ethernet.h>
 
 #include <sys/tsol/label.h>
 #include <sys/tsol/tnet.h>
@@ -348,89 +346,6 @@
 typedef union T_primitives *t_primp_t;
 
 /*
- * Various protocols that encapsulate UDP have no real use for the source port.
- * Instead, they want to vary the source port to provide better equal-cost
- * multipathing and other systems that use fanout. Consider something like
- * VXLAN. If you're actually sending multiple different streams to a single
- * host, if you don't vary the source port, then the tuple of ( SRC IP, DST IP,
- * SRC Port, DST Port) will always be the same.
- *
- * Here, we return a port to hash this to, if we know how to hash it. If for
- * some reason we can't perform an L4 hash, then we just return the default
- * value, usually the default port. After we determine the hash we transform it
- * so that it's in the range of [ min, max ].
- *
- * We'd like to avoid a pull up for the sake of performing the hash. If the
- * first mblk_t doesn't have the full protocol header, then we just send it to
- * the default. If for some reason we have an encapsulated packet that has its
- * protocol header in different parts of an mblk_t, then we'll go with the
- * default port. This means that that if a driver isn't consistent about how it
- * generates the frames for a given flow, it will not always be consistently
- * hashed. That should be an uncommon event.
- */
-uint16_t
-udp_srcport_hash(mblk_t *mp, int type, uint16_t min, uint16_t max,
-    uint16_t def)
-{
-	size_t szused = 0;
-	struct ether_header *ether;
-	struct ether_vlan_header *vether;
-	ip6_t *ip6h;
-	ipha_t *ipha;
-	uint16_t sap;
-	uint64_t hash;
-	uint32_t mod;
-
-	ASSERT(min <= max);
-
-	if (type != UDP_HASH_VXLAN)
-		return (def);
-
-	if (!IS_P2ALIGNED(mp->b_rptr, sizeof (uint16_t)))
-		return (def);
-
-	/*
-	 * The following logic is VXLAN specific to get at the header, if we
-	 * have formats, eg. GENEVE, then we should ignore this.
-	 *
-	 * The kernel overlay device often puts a first mblk_t for the data
-	 * which is just the encap. If so, then we're going to use that and try
-	 * to avoid a pull up.
-	 */
-	if (MBLKL(mp) == VXLAN_HDR_LEN) {
-		if (mp->b_cont == NULL)
-			return (def);
-		mp = mp->b_cont;
-		ether = (struct ether_header *)mp->b_rptr;
-	} else if (MBLKL(mp) < VXLAN_HDR_LEN) {
-		return (def);
-	} else {
-		szused = VXLAN_HDR_LEN;
-		ether = (struct ether_header *)((uintptr_t)mp->b_rptr + szused);
-	}
-
-	/* Can we hold a MAC header? */
-	if (MBLKL(mp) + szused < sizeof (struct ether_header))
-		return (def);
-
-	/*
-	 * We need to lie about the starting offset into the message block for
-	 * convenience. Undo it at the end. We know that inet_pkt_hash() won't
-	 * modify the mblk_t.
-	 */
-	mp->b_rptr += szused;
-	hash = inet_pkt_hash(DL_ETHER, mp, INET_PKT_HASH_L2 |
-	    INET_PKT_HASH_L3 | INET_PKT_HASH_L4);
-	mp->b_rptr -= szused;
-
-	if (hash == 0)
-		return (def);
-
-	mod = max - min + 1;
-	return ((hash % mod) + min);
-}
-
-/*
  * Return the next anonymous port in the privileged port range for
  * bind checking.
  *
@@ -1668,11 +1583,6 @@
 			*i1 = udp->udp_rcvhdr ? 1 : 0;
 			mutex_exit(&connp->conn_lock);
 			return (sizeof (int));
-		case UDP_SRCPORT_HASH:
-			mutex_enter(&connp->conn_lock);
-			*i1 = udp->udp_vxlanhash;
-			mutex_exit(&connp->conn_lock);
-			return (sizeof (int));
 		case UDP_SND_TO_CONNECTED:
 			mutex_enter(&connp->conn_lock);
 			*i1 = udp->udp_snd_to_conn ? 1 : 0;
@@ -1813,26 +1723,6 @@
 			udp->udp_rcvhdr = onoff;
 			mutex_exit(&connp->conn_lock);
 			return (0);
-		case UDP_SRCPORT_HASH:
-			/*
-			 * This should have already been verified, but double
-			 * check.
-			 */
-			if ((error = secpolicy_ip_config(cr, B_FALSE)) != 0) {
-				return (error);
-			}
-
-			/* First see if the val is something we understand */
-			if (*i1 != UDP_HASH_DISABLE && *i1 != UDP_HASH_VXLAN)
-				return (EINVAL);
-
-			if (!checkonly) {
-				mutex_enter(&connp->conn_lock);
-				udp->udp_vxlanhash = *i1;
-				mutex_exit(&connp->conn_lock);
-			}
-			/* Fully handled this option. */
-			return (0);
 		case UDP_SND_TO_CONNECTED:
 			mutex_enter(&connp->conn_lock);
 			udp->udp_snd_to_conn = onoff;
@@ -2121,9 +2011,7 @@
 	uint32_t	cksum;
 	udp_t		*udp = connp->conn_udp;
 	boolean_t	insert_spi = udp->udp_nat_t_endpoint;
-	boolean_t	hash_srcport = udp->udp_vxlanhash;
 	uint_t		ulp_hdr_len;
-	uint16_t	srcport;
 
 	data_len = msgdsize(data_mp);
 	ulp_hdr_len = UDPH_SIZE;
@@ -2130,16 +2018,6 @@
 	if (insert_spi)
 		ulp_hdr_len += sizeof (uint32_t);
 
-	/*
-	 * If we have source port hashing going on, determine the hash before
-	 * we modify the mblk_t.
-	 */
-	if (hash_srcport == B_TRUE) {
-		srcport = udp_srcport_hash(mp, UDP_HASH_VXLAN,
-		    IPPORT_DYNAMIC_MIN, IPPORT_DYNAMIC_MAX,
-		    ntohs(connp->conn_lport));
-	}
-
 	mp = conn_prepend_hdr(ixa, ipp, v6src, v6dst, IPPROTO_UDP, flowinfo,
 	    ulp_hdr_len, data_mp, data_len, us->us_wroff_extra, &cksum, errorp);
 	if (mp == NULL) {
@@ -2151,11 +2029,7 @@
 	ixa->ixa_pktlen = data_len + ixa->ixa_ip_hdr_length;
 
 	udpha = (udpha_t *)(mp->b_rptr + ixa->ixa_ip_hdr_length);
-	if (hash_srcport == B_TRUE) {
-		udpha->uha_src_port = htons(srcport);
-	} else {
-		udpha->uha_src_port = connp->conn_lport;
-	}
+	udpha->uha_src_port = connp->conn_lport;
 	udpha->uha_dst_port = dstport;
 	udpha->uha_checksum = 0;
 	udpha->uha_length = htons(data_len);
@@ -3330,7 +3204,6 @@
 	udp_t		*udp = connp->conn_udp;
 	udp_stack_t	*us = udp->udp_us;
 	boolean_t	insert_spi = udp->udp_nat_t_endpoint;
-	boolean_t	hash_srcport = udp->udp_vxlanhash;
 	uint_t		pktlen;
 	uint_t		alloclen;
 	uint_t		copylen;
@@ -3339,21 +3212,10 @@
 	udpha_t		*udpha;
 	uint32_t	cksum;
 	ip_pkt_t	*ipp;
-	uint16_t	srcport;
 
 	ASSERT(MUTEX_HELD(&connp->conn_lock));
 
 	/*
-	 * If we have source port hashing going on, determine the hash before
-	 * we modify the mblk_t.
-	 */
-	if (hash_srcport == B_TRUE) {
-		srcport = udp_srcport_hash(mp, UDP_HASH_VXLAN,
-		    IPPORT_DYNAMIC_MIN, IPPORT_DYNAMIC_MAX,
-		    ntohs(connp->conn_lport));
-	}
-
-	/*
 	 * Copy the header template and leave space for an SPI
 	 */
 	copylen = connp->conn_ht_iphc_len;
@@ -3451,9 +3313,6 @@
 		*((uint32_t *)(udpha + 1)) = 0;
 
 	udpha->uha_dst_port = dstport;
-	if (hash_srcport == B_TRUE)
-		udpha->uha_src_port = htons(srcport);
-
 	return (mp);
 }
 
@@ -6061,6 +5920,7 @@
 	ushort_t	ipversion;
 	pid_t		pid = curproc->p_pid;
 	ip_xmit_attr_t	*ixa;
+	boolean_t	snd_to_conn;
 
 	ASSERT(DB_TYPE(mp) == M_DATA);
 
@@ -6105,7 +5965,10 @@
 	 * historically we've returned an error if already connected. The
 	 * client can allow this via a sockopt.
 	 */
-	if (udp->udp_state == TS_DATA_XFER && !udp->udp_snd_to_conn) {
+	mutex_enter(&connp->conn_lock);
+	snd_to_conn = (udp->udp_snd_to_conn != 0);
+	mutex_exit(&connp->conn_lock);
+	if (udp->udp_state == TS_DATA_XFER && !snd_to_conn) {
 		UDPS_BUMP_MIB(us, udpOutErrors);
 		return (EISCONN);
 	}
--- old/usr/src/uts/common/inet/udp/udp_opt_data.c	Wed Oct  5 00:33:48 2016
+++ new/usr/src/uts/common/inet/udp/udp_opt_data.c	Wed Oct  5 00:33:48 2016
@@ -21,7 +21,6 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
- * Copyright 2015, Joyent, Inc.
  */
 
 #include <sys/types.h>
@@ -293,7 +292,6 @@
 	},
 { UDP_NAT_T_ENDPOINT, IPPROTO_UDP, OA_RW, OA_RW, OP_PRIVPORT, 0, sizeof (int),
 	0 },
-{ UDP_SRCPORT_HASH, IPPROTO_UDP, OA_R, OA_RW, OP_CONFIG, 0, sizeof (int), 0 },
 { UDP_SND_TO_CONNECTED, IPPROTO_UDP, OA_R, OA_RW, OP_CONFIG, 0, sizeof (int),
 	0 }
 };
--- old/usr/src/uts/common/inet/udp_impl.h	Wed Oct  5 00:33:48 2016
+++ new/usr/src/uts/common/inet/udp_impl.h	Wed Oct  5 00:33:48 2016
@@ -20,7 +20,6 @@
  */
 /*
  * Copyright (c) 2000, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2015, Joyent, Inc.
  */
 
 #ifndef	_UDP_IMPL_H
@@ -179,12 +178,9 @@
 		udp_issocket : 1,	/* socket mode; sockfs is on top */
 		udp_nat_t_endpoint : 1,	/* UDP_NAT_T_ENDPOINT option */
 		udp_rcvhdr : 1,		/* UDP_RCVHDR option */
-		udp_vxlanhash: 1,	/* UDP_SRCPORT_HASH option */
-					/* Because there's only VXLAN, cheat */
-					/* and only use a single bit */
 		udp_snd_to_conn: 1,	/* UDP_SND_TO_CONNECTED option */
 
-		udp_pad_to_bit_31 : 27;
+		udp_pad_to_bit_31 : 28;
 
 	/* Following 2 fields protected by the uf_lock */
 	struct udp_s	*udp_bind_hash; /* Bind hash chain */
No differences encountered
No differences encountered
